// ------ Brothers.h

#ifndef BROTHERS_H
#define BROTHERS_H

#include <Date.h>
#include <ptl.h>

// ---- predicate to make a case-insensitive string compare
struct ltstr {
	// ---- return true if s1 < s2 else return false
    bool operator()(const std::string& s1, const std::string& s2) const
	{ 
	    int i1 = 0, i2 = 0;
	    short int df;
	    char c1, c2;
	    do {
	        c1 = i1 == s1.length() ? 0 : s1[i1];
	        c2 = i2 == s2.length() ? 0 : s2[i2];
	        df = tolower(c1) - tolower(c2);
	        i1++, i2++;
	    } while (c1 && c2 && df == 0);
	    return df < 0;
	}
};

typedef ptl::PTLmap<std::string, Date, ltstr> Brothers;

#endif
