//Title:      EmployeeInfo
//Version:    
//Copyright:  Copyright (c) 1997
//Author:     Bryan Morgan
//Company:    AlphaBeta Technologies
//Description:Human Resources Application

import java.awt.*;
import java.awt.event.*;
import borland.jbcl.control.*;
import borland.jbcl.layout.*;

public class EmployeeFrame extends DecoratedFrame {
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout2 = new XYLayout();
  BevelPanel bevelPanel1 = new BevelPanel();
  StatusBar statusBar = new StatusBar();
  GroupBox FieldGroupBox = new GroupBox();
  GroupBox ButtonGroupBox = new GroupBox();
  XYLayout xYLayout1 = new XYLayout();
  TextField AddressField = new TextField();
  TextField CityField = new TextField();
  TextField StateField = new TextField();
  TextField TitleField = new TextField();
  TextField SSNField = new TextField();
  TextField SalaryField = new TextField();
  Label NameLabel = new Label();
  Label AddressLabel = new Label();
  Label CityLabel = new Label();
  Label StateLabel = new Label();
  Label SSNLabel = new Label();
  Label SalaryLabel = new Label();
  Label TitleLabel = new Label();
  XYLayout xYLayout3 = new XYLayout();
  Button FirstButton = new Button();
  Button NextButton = new Button();
  Button PreviousButton = new Button();
  Button LastButton = new Button();
  Button UpdateButton = new Button();
  Button DeleteButton = new Button();
  Button NewButton = new Button();
  TextField NameField = new TextField();
  Button CancelButton = new Button();

  public static EmployeeServer.EmployeeInfo infoObject;

  // Current Record Number
  private int mRecord = 0;

  // Static variables used to track edit mode
  private static int EDIT = 0;
  private static int ADD = 1;

  // Global variable used to track current mode
  private int mMode = EDIT;

  // Update on-screen text boxes with an Employee object
  public void UpdateScreen(int empNum)
  {
         EmployeeServer.Employee emp = infoObject.getEmployee(empNum);
         if (emp != null)
         {
                  NameField.setText(emp.Name);
                  AddressField.setText(emp.Address);
                  CityField.setText(emp.City);
                  StateField.setText(emp.State);
                  SSNField.setText(java.lang.String.valueOf(emp.SSN));
                  SalaryField.setText(java.lang.String.valueOf(emp.Salary));
                  TitleField.setText(emp.Title);
         }
  }

  //Construct the frame
  public EmployeeFrame() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  public void jbInit() throws Exception{
    this.setLayout(borderLayout1);
    this.setSize(new Dimension(563, 369));
    this.setTitle("AlphaBeta Employee Info");
    statusBar.setFont(new Font("SansSerif", 2, 12));
    statusBar.setText("AlphaBeta:  Where An Employee Is More Than A Number!");
    FieldGroupBox.setLayout(xYLayout1);
    FieldGroupBox.setLabel("Employee Info");
    ButtonGroupBox.setLayout(xYLayout3);
    ButtonGroupBox.setLabel("Operations");
    FirstButton.setFont(new Font("Dialog", 1, 12));
    FirstButton.setActionCommand("FirstButton");
    FirstButton.addActionListener(new EmployeeFrame_FirstButton_actionAdapter(this));
    FirstButton.setLabel("First");
    NextButton.setFont(new Font("Dialog", 1, 12));
    NextButton.setActionCommand("NextButton");
    NextButton.addActionListener(new EmployeeFrame_NextButton_actionAdapter(this));
    NextButton.setLabel("Next");
    PreviousButton.setFont(new Font("Dialog", 1, 12));
    PreviousButton.setActionCommand("PreviousButton");
    PreviousButton.addActionListener(new EmployeeFrame_PreviousButton_actionAdapter(this));
    PreviousButton.setLabel("Previous");
    LastButton.setFont(new Font("Dialog", 1, 12));
    LastButton.setActionCommand("LastButton");
    LastButton.addActionListener(new EmployeeFrame_LastButton_actionAdapter(this));
    LastButton.setLabel("Last");
    UpdateButton.setFont(new Font("Dialog", 1, 12));
    UpdateButton.setActionCommand("UpdateButton");
    UpdateButton.addActionListener(new EmployeeFrame_UpdateButton_actionAdapter(this));
    UpdateButton.setLabel("Save");
    DeleteButton.setFont(new Font("Dialog", 1, 12));
    DeleteButton.setActionCommand("DeleteButton");
    DeleteButton.addActionListener(new EmployeeFrame_DeleteButton_actionAdapter(this));
    DeleteButton.setLabel("Delete");
    NewButton.setFont(new Font("Dialog", 1, 12));
    NewButton.setActionCommand("NewButton");
    CancelButton.setEnabled(false);
    CancelButton.setFont(new Font("Dialog", 1, 12));
    CancelButton.setActionCommand("CancelButton");
    CancelButton.addActionListener(new EmployeeFrame_CancelButton_actionAdapter(this));
    CancelButton.setLabel("Cancel");
    NewButton.addActionListener(new EmployeeFrame_NewButton_actionAdapter(this));
    NewButton.setLabel("New");
    NameLabel.setFont(new Font("Dialog", 1, 12));
    NameLabel.setText("Name");    
    AddressLabel.setFont(new Font("Dialog", 1, 12));
    AddressLabel.setText("Address");
    CityLabel.setFont(new Font("Dialog", 1, 12));
    CityLabel.setText("City");
    StateLabel.setFont(new Font("Dialog", 1, 12));
    StateLabel.setText("State");
    SSNLabel.setFont(new Font("Dialog", 1, 12));
    SSNLabel.setText("SSN");
    SalaryLabel.setFont(new Font("Dialog", 1, 12));
    SalaryLabel.setText("Salary");
    TitleLabel.setFont(new Font("Dialog", 1, 12));
    TitleLabel.setText("Title");
    bevelPanel1.setLayout(xYLayout2);
    this.add(statusBar, BorderLayout.SOUTH);
    this.add(bevelPanel1, BorderLayout.CENTER);
    bevelPanel1.add(FieldGroupBox, new XYConstraints(10, 9, 368, 296));
    FieldGroupBox.add(NameLabel, new XYConstraints(15, 10, 61, -1));
    FieldGroupBox.add(AddressLabel, new XYConstraints(15, 47, -1, -1));
    FieldGroupBox.add(CityLabel, new XYConstraints(15, 88, -1, -1));
    FieldGroupBox.add(StateLabel, new XYConstraints(15, 128, -1, -1));
    FieldGroupBox.add(SSNLabel, new XYConstraints(15, 165, -1, -1));
    FieldGroupBox.add(SalaryLabel, new XYConstraints(15, 201, -1, -1));
    FieldGroupBox.add(TitleLabel, new XYConstraints(15, 236, -1, -1));
    FieldGroupBox.add(NameField, new XYConstraints(99, 14, 230, 28));    
    FieldGroupBox.add(AddressField, new XYConstraints(99, 49, 230, 30));
    FieldGroupBox.add(CityField, new XYConstraints(99, 87, 230, 30));
    FieldGroupBox.add(StateField, new XYConstraints(99, 125, 230, 30));
    FieldGroupBox.add(SSNField, new XYConstraints(99, 161, 230, 30));
    FieldGroupBox.add(SalaryField, new XYConstraints(99, 196, 230, 30));    
    FieldGroupBox.add(TitleField, new XYConstraints(99, 231, 230, 30));
    bevelPanel1.add(ButtonGroupBox, new XYConstraints(384, 12, 163, 297));
    ButtonGroupBox.add(FirstButton, new XYConstraints(22, 6, 92, -1));
    ButtonGroupBox.add(PreviousButton, new XYConstraints(22, 33, 92, -1));    
    ButtonGroupBox.add(NextButton, new XYConstraints(22, 60, 92, -1));
    ButtonGroupBox.add(LastButton, new XYConstraints(22, 87, 92, -1));
    ButtonGroupBox.add(NewButton, new XYConstraints(20, 154, 92, -1));    
    ButtonGroupBox.add(UpdateButton, new XYConstraints(20, 207, 92, -1));
    ButtonGroupBox.add(DeleteButton, new XYConstraints(20, 181, 92, -1));
    ButtonGroupBox.add(CancelButton, new XYConstraints(20, 234, 92, 25));

   // Initialize the ORB
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();

    // Locate and retrieve EmployeeInfo object from server
    EmployeeFrame.infoObject = EmployeeServer.EmployeeInfoHelper.bind(orb, "EmployeeInfo");

    if (infoObject.Count() > 0)
        UpdateScreen(0);
  }

  void FirstButton_actionPerformed(ActionEvent e)
  {
       mRecord = 0;

       if (infoObject.Count() > 0)
          UpdateScreen(mRecord);
  }

  void NextButton_actionPerformed(ActionEvent e)
  {
    if (infoObject.Count() > (mRecord + 1))
    {
       mRecord = mRecord + 1;
       UpdateScreen(mRecord);
    }
  }

  void PreviousButton_actionPerformed(ActionEvent e)
  {
    if (mRecord > 0)
    {
       mRecord = mRecord - 1;
       UpdateScreen(mRecord);
    }
  }

  void LastButton_actionPerformed(ActionEvent e)
  {
    if (infoObject.Count() > 0)
    {
       mRecord = infoObject.Count() - 1;
       UpdateScreen(mRecord);
    }
  }

  void UpdateButton_actionPerformed(ActionEvent e)
  {
       // Retrieve user's inputs
       EmployeeServer.Employee temp = new EmployeeServer.Employee();
       temp.Name = NameField.getText();
       temp.Address = AddressField.getText();
       temp.City = CityField.getText();
       temp.State = StateField.getText();
       temp.Title = TitleField.getText();
       java.lang.Long tempLong = new java.lang.Long(SSNField.getText());
       temp.SSN = tempLong.longValue();
       java.lang.Float tempFloat = new java.lang.Float(SalaryField.getText());
       temp.Salary = tempFloat.floatValue();

       //Update the server object
       if (mMode == ADD)
       {
        infoObject.newEmployee(temp);
        mRecord = infoObject.Count() - 1;
       }
       else if (infoObject.Count() > 0)
       {
        infoObject.updateEmployee(mRecord, temp);
       }

       //Update display
       mMode = EDIT;
       FirstButton.enable();
       NextButton.enable();
       PreviousButton.enable();
       LastButton.enable();
       DeleteButton.enable();
       NewButton.enable();
       CancelButton.disable();
  }

  void DeleteButton_actionPerformed(ActionEvent e)
  {
       infoObject.deleteEmployee(mRecord);

       if (infoObject.Count() <= 0)
       {
          mRecord = 0;
          NameField.setText("");
          AddressField.setText("");
          CityField.setText("");
          StateField.setText("");
          SSNField.setText("");
          SalaryField.setText("");
          TitleField.setText("");
       }
       else if (mRecord > (infoObject.Count() - 1))
       {
          mRecord = infoObject.Count() - 1;
          UpdateScreen(mRecord);
       }
       else
       {
           UpdateScreen(mRecord);
       }
  }

  void NewButton_actionPerformed(ActionEvent e)
  {
       mMode = ADD;
       FirstButton.disable();
       NextButton.disable();
       PreviousButton.disable();
       LastButton.disable();
       DeleteButton.disable();
       NewButton.disable();
       CancelButton.enable();
       NameField.setText("");
       AddressField.setText("");
       CityField.setText("");
       StateField.setText("");
       SSNField.setText("");
       SalaryField.setText("");
       TitleField.setText("");
  }

  void CancelButton_actionPerformed(ActionEvent e)
  {
       mMode = EDIT;
       
       if (infoObject.Count() > 0)
       {
          UpdateScreen(mRecord);
       }
       FirstButton.enable();
       NextButton.enable();
       PreviousButton.enable();
       LastButton.enable();
       DeleteButton.enable();
       NewButton.enable();
       CancelButton.disable();
  }

}

class EmployeeFrame_DeleteButton_actionAdapter implements java.awt.event.ActionListener {
  EmployeeFrame adaptee;

  EmployeeFrame_DeleteButton_actionAdapter(EmployeeFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.DeleteButton_actionPerformed(e);
  }
}


