
import java.util.*;
import java.io.Serializable;

public class MonteCarlo implements Serializable {

    public double estimateIntegral(double intervalStart, 
				   double intervalEnd,
                                   long iterations, Random random,
                                   FofX function)
    {
        double intermediate = 0.0;
	double intervalLength = intervalEnd - intervalStart;
        double x;

	for (int i = 0; i < iterations; i++)
	{
	    x = intervalStart + (random.nextDouble() * intervalLength);
            intermediate += function.computeFof(x);
        }

	return (intermediate / iterations);
    }
}

