
import java.lang.Math;
import java.util.Random;
import java.io.Serializable;
import COM.objectspace.voyager.*;

public class RemoteMonteCarloTest1 implements FofX, Serializable {

    public double computeFof(double x)
    {
	return Math.sqrt(x);
    }

    public static void main(String[] args)
	throws VoyagerException
    {
        VMonteCarlo estimator = null;
        try
        {
            estimator = (VMonteCarlo)
		    VObject.forObjectAt(args[0] + ":7777/MCServer1");
        }
        catch(ObjectNotFoundException e) { }
        if (estimator == null) 
        {
           VSojournerMaster master = (VSojournerMaster)
                   VObject.forObjectAt(args[0] + ":7777/sojournerNodeControl");
	   estimator = new VMonteCarlo(args[0] + ":7777/MCServer1");
           estimator.liveForever();
           master.receiveGuest(estimator);
        }

	RemoteMonteCarloTest function  = new RemoteMonteCarloTest();
        double answer;
	System.out.print("The area under the curve of the square ");
	System.out.print("root of x from 0 to 100 is ");
	answer = estimator.estimateIntegral(0.0, 100.0, 1000,
                                            new Random(), function);
        System.out.println(answer);
	Voyager.shutdown();
    }
}
