
import java.net.*;
import java.util.*;
import COM.objectspace.voyager.*;

public class SojournerLocalRegistry {

    String                    localMachine;
    VSojournerCentralRegistry registry;

    public SojournerLocalRegistry(String masterSojournerServer)
        throws UnknownHostException,
               COM.objectspace.voyager.VoyagerException
    {
	InetAddress myAddress = InetAddress.getLocalHost();
        localMachine = myAddress.getHostName() + ":7777"; // Sojourner servers
							  // run on port 7777
							  // (by convention)

	String centralRegistryName = masterSojournerServer
					  + ":7777/sojournerRegistry";

	registry = (VSojournerCentralRegistry)
		       VObject.forObjectAt(centralRegistryName);
    }	

    public void register()
	throws COM.objectspace.voyager.VoyagerException
    {
	registry.register(localMachine);
    }

    public void unregister()
	throws COM.objectspace.voyager.VoyagerException
    {    
	registry.unregister(localMachine);
    }
	
    public Enumeration getRegisteredMachines()
	throws COM.objectspace.voyager.VoyagerException
    {
	Hashtable registryCopy = registry.toLocal();
	return registryCopy.keys();
    }
}