
import java.util.*;
import java.net.*;
import COM.objectspace.voyager.*;

public class SojournerMaster extends Thread 
                             implements SojournerHost {

    SojournerLocalRegistry localRegistry;
    Vector                 guests;
    boolean                stopNow = false;

    public SojournerMaster()
	throws VoyagerException, java.net.UnknownHostException
    {
	guests = new Vector();
	VSojournerCentralRegistry centralRegistry =
	    new VSojournerCentralRegistry("localhost:7777/sojournerRegistry");
	centralRegistry.liveForever();
        localRegistry = new SojournerLocalRegistry("localhost");
    }	

    public boolean receiveGuest(VObject newGuest)
    {
       guests.addElement(newGuest);
       return true;
    }

    public void run()
    {
	while(true)
	{
            try
            {
                Thread.sleep(60000);
            }
	    catch(InterruptedException e) { }
	    if (stopNow) return;
	    if (guests.isEmpty()) continue;
	    Enumeration newHostEnumeration;
	    try
	    {
                newHostEnumeration = localRegistry.getRegisteredMachines();
	    }
	    catch(VoyagerException e) { continue; }
	    if (!newHostEnumeration.hasMoreElements()) continue;
            Vector newHosts = new Vector();
            while (newHostEnumeration.hasMoreElements())
              newHosts.addElement(newHostEnumeration.nextElement());
	    int jobsGoing = ((guests.size() < newHosts.size()) ?
                                          guests.size() : newHosts.size());
            for (int i = 0; i < jobsGoing; i++)
            {
		try
		{
                    String targetMachineName = 
                        (String) newHosts.elementAt(i);
                    SojournerHost targetMachine =
                        (SojournerHost) 
                            VObject.forObjectAt(targetMachineName + 
                                                "/sojournerNodeControl");
                    if (targetMachine.receiveGuest((VObject) 
                                                  guests.elementAt(0)))
		    {
			((VObject) 
                            guests.elementAt(0)).moveTo(targetMachineName);
			guests.removeElementAt(0);
                    }
		}
		catch(VoyagerException e) { }
	    }
	}
    }

    public void stopNode()
	throws VoyagerException
    {
	for (int i = 0; i < guests.size(); i++)
	{
	    VObject doomedGuest = (VObject) guests.elementAt(i);
            doomedGuest.dieNow();
	}
	stopNow = true;
    }
}
