
import COM.objectspace.voyager.*;

public class SojournerStartStopNode {

    public static void main(String[] args)
	throws VoyagerException,
               java.net.UnknownHostException
    {
        if (args.length == 0) { printUsage(); return; }
        if (args.length > 2)  { printUsage(); return; }
	if (args[0].equals("start")) 
        {
            if (args.length == 1) startMaster();
            else startNode(args[1]);
        }
	else if ((args[0].equals("stop")) && (args.length == 1)) stopNode();
	     else printUsage();
    }

    static void startNode(String masterSojournerServer)
	throws VoyagerException,
               java.net.UnknownHostException
    {
        VSojournerNodeControl node = null;
        try
        {
            node = (VSojournerNodeControl)
		    VObject.forObjectAt("localhost:7777/sojournerNodeControl");
        }
        catch(ObjectNotFoundException e) { }
        if (node != null) 
	{
	    System.err.println("The Sojourner system is already running here");
	    return;
	}
        node = new VSojournerNodeControl(masterSojournerServer,
                                        "localhost:7777/sojournerNodeControl");
        node.start();
        node.liveForever();
	Voyager.shutdown();
    }

    static void startMaster()
	throws VoyagerException,
               java.net.UnknownHostException
    {
        VSojournerCentralRegistry reg = null;
        try
        {
            reg = (VSojournerCentralRegistry)
		    VObject.forObjectAt("localhost:7777/sojournerRegistry");
        }
        catch(ObjectNotFoundException e) { }
        if (reg != null) 
	{
	    System.err.println("This is already a Sojourner Master machine");
	    return;
	}
        VSojournerMaster master = new 
                 VSojournerMaster("localhost:7777/sojournerNodeControl");
        master.start();
        master.liveForever();
	Voyager.shutdown();
    }


    static void stopNode()
	throws VoyagerException
    {
        VSojournerCentralRegistry reg = null;
        try
        {
            reg = (VSojournerCentralRegistry)
		    VObject.forObjectAt("localhost:7777/sojournerRegistry");
        }
        catch(ObjectNotFoundException e) { }
        SojournerHost node = null;
        try
        {
            node = (SojournerHost)
		    VObject.forObjectAt("localhost:7777/sojournerNodeControl");
        }
        catch(ObjectNotFoundException e) { }
        if (node == null) 
	{
	    System.err.println("The Sojourner system is not running here");
	    return;
	}	
        node.stopNode();
        ((VObject) node).dieNow();
        if (reg != null) reg.dieNow();
        Voyager.shutdown();
    }


    static void printUsage()
    {    
        System.out.println(
          "Usage: java SojournerStartStopNode <<start  <masternode>> | stop>");
    }	
}









