// ----------- ptlstore.cpp
#include <ptl.h>
namespace PersistentTemplateLibrary {
// ========================================================
//                  PTLStore class
// class to encapsulate container store disk file
// ========================================================
void PTLStore::open(const std::string& nm)
{
    // --- opening for input
    isreading = true;
    name = nm;
    ifile.open(name.c_str(), std::ios::binary);
    if (!ifile.fail())
        ifile.read(reinterpret_cast<char*>(&objcount), sizeof objcount);
}
void PTLStore::open(int ct)
{
    // --- opening for output
    objcount = ct;
    isreading = false;
    ofile.open(name.c_str(), std::ios::binary);
    ofile.write(reinterpret_cast<char*>(&objcount), sizeof objcount);
}
void PTLStore::close()
{
    if (isreading)
        ifile.close();
    else
        ofile.close();
}
// ========================================================
// overloaded insertion and extraction operators
// to manage disk I/O of Standard C++ string objects
// ========================================================
PTLStore& operator<<(PTLStore& cs, const std::string& str)
{
    int len = str.length();
    cs.ofile.write(reinterpret_cast<char*>(&len), sizeof len);
    cs.ofile.write(str.c_str(), len);
    return cs;
}
PTLStore& operator>>(PTLStore& cs, std::string& str)
{
    int len;
    cs.ifile.read(reinterpret_cast<char*>(&len), sizeof len);
    char* cstr = new char[len+1];
    cs.ifile.read(cstr, len);
    cstr[len] = '\0';
    str = cstr;
    return cs;
}

} // namespace PersistentTemplateLibrary
